# -*- coding: utf-8 -*-
"""
Created on Thu Sep 30 09:33:03 2021

@author: kalou
"""
# στο πρώτο τμήμα  επαλήθευση του αριθμητικού παραδείγματος 
import numpy as np
import quantecon as qe
from scipy.stats import binom
import scipy.sparse as sparse
from quantecon import compute_fixed_point
from quantecon.markov import DiscreteDP

cap=2
n_w=2
p_w=np.array([0.1,.7,.2])
#p_w=np.array([binom.pmf(range(n_w+1),n_w,.6)])
# beta=.9
beta=1
n=cap
m=cap
s_indices = []
a_indices = []
Q = []
R = []
def r(x,a):
    return a+p_w[0]*((x+a)**2)+p_w[1]*((x+a-1)**2)+p_w[2]*((x+a-2)**2)

for s in range(n+1):
    for a in range(cap-s+ 1):  # All feasible a at this s
        s_indices.append(s)
        a_indices.append(a)        
        R.append(-r(s, a))
        q=np.zeros(n+1)
        q[0]=sum(p_w[s+a:n_w+1])
        if s+a>=1:
            v=np.arange(max(s+a-n_w, 1),min(n,s+a)+1)
            q[v]=p_w[(s+a-v)]
        else:
            q[1:n]=np.zeros(n-1)
            
        Q.append(q)
             

ddp = qe.markov.DiscreteDP(R, Q, beta, s_indices, a_indices )

res=qe.markov.ddp.backward_induction(ddp,T=3,v_term=None)
vs=res[0]
sigmas=res[1]

# results = ddp.solve(method='policy_iteration')

#-----------------------------------------------------------------

# γενικευση του παραδείγματος, αποθήκες οποιασδήποτε χωρητικότητας,
# ζήτηση με πολλαπλές τιμές 

import numpy as np
import quantecon as qe
from scipy.stats import binom
import scipy.sparse as sparse
from quantecon import compute_fixed_point
from quantecon.markov import DiscreteDP

cap=10
n_w=12
p_w=binom.pmf(range(n_w+1),n_w,.6)
# beta=.9
beta=1
n=cap
m=cap
s_indices = []
a_indices = []
Q = []
R = []
def r(x,a):
    su=.0
    for w in range(n_w+1):
        su=su+p_w[w]*((x+a-w)**2)
    return su+a
    
    
# return a+p_w[0]*((x+a)**2)+p_w[1]*((x+a-1)**2)+p_w[2]*((x+a-2)**2)

for s in range(n+1):
    for a in range(cap-s+ 1):  # All feasible a at this s
        s_indices.append(s)
        a_indices.append(a)        
        R.append(-r(s, a))
        q=np.zeros(n+1)
        q[0]=sum(p_w[s+a:n_w+1])
        if s+a>=1:
            v=np.arange(max(s+a-n_w, 1),min(n,s+a)+1)
            q[v]=p_w[(s+a-v)]
        else:
            q[1:n]=np.zeros(n-1)
            
        Q.append(q)
             

ddp = qe.markov.DiscreteDP(R, Q, beta, s_indices, a_indices )

res=qe.markov.ddp.backward_induction(ddp,T=5,v_term=None)
vs=res[0]
sigmas=res[1]
import matplotlib.pyplot as plt
plt.plot(-vs[0])

plt.plot(sigmas[0])


#-------------------------------------------------------------------

# η παραπάνω γενίκευση σε άπειρο χρονικό ορίζοντα

import numpy as np
import quantecon as qe
from scipy.stats import binom
import scipy.sparse as sparse
from quantecon import compute_fixed_point
from quantecon.markov import DiscreteDP
import matplotlib.pyplot as plt

cap=10
n_w=12
p_w=binom.pmf(range(n_w+1),n_w,.6) #ο
beta=.9
n=cap
m=cap
s_indices = []
a_indices = []
Q = []
R = []
def r(x,a):
    su=.0
    for w in range(n_w+1):
        su=su+p_w[w]*((x+a-w)**2)
    return su+a
    
    
# return a+p_w[0]*((x+a)**2)+p_w[1]*((x+a-1)**2)+p_w[2]*((x+a-2)**2)

for s in range(n+1):
    for a in range(cap-s+ 1):  # All feasible a at this s
        s_indices.append(s)
        a_indices.append(a)        
        R.append(-r(s, a))
        q=np.zeros(n+1)
        q[0]=sum(p_w[s+a:n_w+1])
        if s+a>=1:
            v=np.arange(max(s+a-n_w, 1),min(n,s+a)+1)
            q[v]=p_w[np.flip(s+a-v)]
        else:
            q[1:n]=np.zeros(n-1)
            
        Q.append(q)
             

ddp = qe.markov.DiscreteDP(R, Q, beta, s_indices, a_indices )

res_val_iter=ddp.solve(method='value_iteration') #επανάληψη αξίας
dir(res_val_iter)
res_val_iter.v             # αξία υπολογισμένη σε 113 βήματα
plt.plot(-res_val_iter.v)

print(res_val_iter.num_iter)
print(res_val_iter.max_iter)
print(res_val_iter.sigma)
plt.plot(res_val_iter.sigma)

# στασιμη κατανομή της αλυσιδας που παράγει η βέλτιστη πολιτική
res_val_iter.mc.stationary_distributions

# λύση με επανάληψη πολιτικής 

res_pol_iter=ddp.solve(method='policy_iteration') #επανάληψη πολιτικής
dir(res_pol_iter)
res_pol_iter.v             
plt.plot(-res_pol_iter.v)

print(res_pol_iter.num_iter)
print(res_pol_iter.max_iter)
print(res_pol_iter.sigma)
plt.plot(res_pol_iter.sigma)

%timeit ddp.solve(method='value_iteration')
%timeit ddp.solve(method='policy_iteration')
%timeit ddp.solve(method='modified_policy_iteration')
